/************************************************************************/
/************         Datapath  Macros                      *************/
/************************************************************************/
/*									*/
/* Module Name:	 	            	                        	*/
/* File Name:	 	dp_macros.v                            		*/
/* Function:		Collection of macros for 64b datapath pieces	*/
/*									*/
/* Language: 		Verilog						*/
/*									*/
/* Creator:		Andrew Chang  					*/
/*									*/
/*									*/
/* History:								*/
/*		971203	achang	Created	CB_62B_MUX			*/
/*		971211	achang	Created	BITSLICE_MUX			*/
/*									*/
/* Copyright (C) 1994, 1995, 1996, 1997, 1998 Andrew Chang              */
/*                                                                      */
/* Massachusetts Institute of Technology                                */
/* Concurrent VLSI Architecture Group                                   */
/* All rights reserved                                                  */
/*									*/
/************************************************************************/

`include "/home/gn/achang/THESIS/EXPERIMENTS/VERILOG/BEHAV/RELEASE/cb.vhout"

/*==>>*/
  module CB_62B_MUX                        // 62b AOI22 based mux
    (
	sel0, sel1,
	in0, in1, 
	dout


     );
    input sel0, sel1;
    input [`WORD_W-3:0] in0, in1;
    output [`WORD_W-3:0] dout;

/*<<==*/
	
   AOI22 cbmxb0 (dout[0], in0[0], sel0, in1[0], sel1);		   
   AOI22 cbmxb1 (dout[1], in0[1], sel0, in1[1], sel1);		   
   AOI22 cbmxb2 (dout[2], in0[2], sel0, in1[2], sel1);		   
   AOI22 cbmxb3 (dout[3], in0[3], sel0, in1[3], sel1);		   
   AOI22 cbmxb4 (dout[4], in0[4], sel0, in1[4], sel1);		   
   AOI22 cbmxb5 (dout[5], in0[5], sel0, in1[5], sel1);		   
   AOI22 cbmxb6 (dout[6], in0[6], sel0, in1[6], sel1);		   
   AOI22 cbmxb7 (dout[7], in0[7], sel0, in1[7], sel1);		   
   AOI22 cbmxb8 (dout[8], in0[8], sel0, in1[8], sel1);		   
   AOI22 cbmxb9 (dout[9], in0[9], sel0, in1[9], sel1);		   
//	
   AOI22 cbmxb10 (dout[10], in0[10], sel0, in1[10], sel1);		   
   AOI22 cbmxb11 (dout[11], in0[11], sel0, in1[11], sel1);		   
   AOI22 cbmxb12 (dout[12], in0[12], sel0, in1[12], sel1);		   
   AOI22 cbmxb13 (dout[13], in0[13], sel0, in1[13], sel1);		   
   AOI22 cbmxb14 (dout[14], in0[14], sel0, in1[14], sel1);		   
   AOI22 cbmxb15 (dout[15], in0[15], sel0, in1[15], sel1);		   
   AOI22 cbmxb16 (dout[16], in0[16], sel0, in1[16], sel1);		   
   AOI22 cbmxb17 (dout[17], in0[17], sel0, in1[17], sel1);		   
   AOI22 cbmxb18 (dout[18], in0[18], sel0, in1[18], sel1);		   
   AOI22 cbmxb19 (dout[19], in0[19], sel0, in1[19], sel1);		   
//	
   AOI22 cbmxb20 (dout[20], in0[20], sel0, in1[20], sel1);		   
   AOI22 cbmxb21 (dout[21], in0[21], sel0, in1[21], sel1);		   
   AOI22 cbmxb22 (dout[22], in0[22], sel0, in1[22], sel1);		   
   AOI22 cbmxb23 (dout[23], in0[23], sel0, in1[23], sel1);		   
   AOI22 cbmxb24 (dout[24], in0[24], sel0, in1[24], sel1);		   
   AOI22 cbmxb25 (dout[25], in0[25], sel0, in1[25], sel1);		   
   AOI22 cbmxb26 (dout[26], in0[26], sel0, in1[26], sel1);		   
   AOI22 cbmxb27 (dout[27], in0[27], sel0, in1[27], sel1);		   
   AOI22 cbmxb28 (dout[28], in0[28], sel0, in1[28], sel1);		   
   AOI22 cbmxb29 (dout[29], in0[29], sel0, in1[29], sel1);		   
//	
   AOI22 cbmxb30 (dout[30], in0[30], sel0, in1[30], sel1);		   
   AOI22 cbmxb31 (dout[31], in0[31], sel0, in1[31], sel1);		   
   AOI22 cbmxb32 (dout[32], in0[32], sel0, in1[32], sel1);		   
   AOI22 cbmxb33 (dout[33], in0[33], sel0, in1[33], sel1);		   
   AOI22 cbmxb34 (dout[34], in0[34], sel0, in1[34], sel1);		   
   AOI22 cbmxb35 (dout[35], in0[35], sel0, in1[35], sel1);		   
   AOI22 cbmxb36 (dout[36], in0[36], sel0, in1[36], sel1);		   
   AOI22 cbmxb37 (dout[37], in0[37], sel0, in1[37], sel1);		   
   AOI22 cbmxb38 (dout[38], in0[38], sel0, in1[38], sel1);		   
   AOI22 cbmxb39 (dout[39], in0[39], sel0, in1[39], sel1);		   
//	
   AOI22 cbmxb40 (dout[40], in0[40], sel0, in1[40], sel1);		   
   AOI22 cbmxb41 (dout[41], in0[41], sel0, in1[41], sel1);		   
   AOI22 cbmxb42 (dout[42], in0[42], sel0, in1[42], sel1);		   
   AOI22 cbmxb43 (dout[43], in0[43], sel0, in1[43], sel1);		   
   AOI22 cbmxb44 (dout[44], in0[44], sel0, in1[44], sel1);		   
   AOI22 cbmxb45 (dout[45], in0[45], sel0, in1[45], sel1);		   
   AOI22 cbmxb46 (dout[46], in0[46], sel0, in1[46], sel1);		   
   AOI22 cbmxb47 (dout[47], in0[47], sel0, in1[47], sel1);		   
   AOI22 cbmxb48 (dout[48], in0[48], sel0, in1[48], sel1);		   
   AOI22 cbmxb49 (dout[49], in0[49], sel0, in1[49], sel1);		   
//	
   AOI22 cbmxb50 (dout[50], in0[50], sel0, in1[50], sel1);		   
   AOI22 cbmxb51 (dout[51], in0[51], sel0, in1[51], sel1);		   
   AOI22 cbmxb52 (dout[52], in0[52], sel0, in1[52], sel1);		   
   AOI22 cbmxb53 (dout[53], in0[53], sel0, in1[53], sel1);		   
   AOI22 cbmxb54 (dout[54], in0[54], sel0, in1[54], sel1);		   
   AOI22 cbmxb55 (dout[55], in0[55], sel0, in1[55], sel1);		   
   AOI22 cbmxb56 (dout[56], in0[56], sel0, in1[56], sel1);		   
   AOI22 cbmxb57 (dout[57], in0[57], sel0, in1[57], sel1);		   
   AOI22 cbmxb58 (dout[58], in0[58], sel0, in1[58], sel1);		   
   AOI22 cbmxb59 (dout[59], in0[59], sel0, in1[59], sel1);		   
//	
   AOI22 cbmxb60 (dout[60], in0[60], sel0, in1[60], sel1);		   
   AOI22 cbmxb61 (dout[61], in0[61], sel0, in1[61], sel1);		   



  endmodule

  module BITSLICE_MUX                        // 62b AOI22 based mux
    (
	sel0, sel1,
	in0, in1, 
	dout


     );
    input sel0, sel1;
    input [`BIT_W-1:0] in0, in1;
    output [`BIT_W-1:0] dout;

/*<<==*/
	
   AOI22 cbmxb0 (dout[0], in0[0], sel0, in1[0], sel1);		   

  endmodule

